Subject: bug#39390: 28.0.50; prettify-symbols-mode confuses display when start/end faces are different

From: Eli Zaretskii <[email-masked]>
Date: Mon, 17 Feb 2020 22:14:45 +0200

> Cc: [email-masked], [email-masked]
> From: Raphael 'kena' Poss <[email-masked]>
> Date: Mon, 17 Feb 2020 14:28:09 -0500
> 
> > We are talking about 2 different things.  I was talking about
> > composing characters across face changes, whereas you were talking
> > about handling invalid composition rules, such as the one you tried to
> > use.
> 
> Look there is nothing else that determines what is "valid" and "invalid"
> than what the docs say and what emacs allow me to configure. At this
> point neither the doc of `compose-region` nor its code prevent me from
> using this configuration, so from the user's perspective (mine) the
> configuration is valid -- and instead I find a bug in the redisplay code.
> 
> If you want to hold a position that the configuration is invalid, Emacs
> (or some function) needs to be first taught to refuse it.

If someone wants to submit patches to detect that this is indeed
invalid, those patches will be welcome.  But I must note that it will
not be easy, because compose-region _can_ accept strings, it just
assigns special meaning to the string's characters, as described in
the doc string.  IOW, your string is "valid" by being a string, but
"invalid" in that it causes incorrect display.